N = 1000;   % Size of the training sample
extr = 8;   % Largest coordinate we care about when plotting
step = 0.1; % Grid step size for plotting the classification regions
k = 1;      % How many neighbors to use for classification

% Make a Gaussian disk of positive samples surrounded by an overlapping
% ring of negative ones
[positive, negative] = onion(N);

% Group the samples and their labels. This is our training set
sample = [positive, negative];
label = [ones(1, size(positive, 2)), zeros(1, size(negative, 2))];

% To display the decision regions, classify every point in a fine grid on
% the plane using k nearest neighbors
g = grid(extr, step);
glabel = knn(g, sample, label, k);

figure(1)
clf
plot(positive(1, :), positive(2, :), '.r')
hold on
plot(negative(1, :), negative(2, :), '.b')
negative(:, find(negative(1,:) .^ 2 + negative(2,:) .^ 2 < 1.3)) = [];
axis([-extr extr -extr extr])
axis equal
axis off

figure(2)
clf
plot(g(1, glabel), g(2, glabel), '.r')
hold on
plot(g(1, ~glabel), g(2, ~glabel), '.b')
if k == 1
    count = '';
    suffix = '';
else
    count = sprintf('%d ', k);
    suffix = 's';
end
title(sprintf('%sNearest Neighbor%s', count, suffix))